&lt;?php
/**
 * email module service
 * @author Philipp Kamps &lt;pkamps@probusiness.de&gt;
 * @copyright Copyright (C) 2003 Free Software Foundation http://www.fsf.org/
 * @license http://www.fsf.org/licenses/gpl.html GNU General Public License
 * @package email
 * @subpackage sevice
 * @version $Id:
 */
 
class email_service
{

	var $msg_bootstrap; //email.msg_bootstrap
	var $bopreferences; 

	// constructor
	function email_service()
	{
		$this-&gt;bopreferences = CreateObject('email.bopreferences');
	}
	
/**
* The method provides the list of email folders
* @access public
* @return array
*/
	function getFolderContent()
	{
		$tpl_set = $GLOBALS['phpgw_info']['user']['preferences']['common']['template_set'];
		
		// make sure we have msg object and a server stream
		$this-&gt;msg_bootstrap = CreateObject(&quot;email.msg_bootstrap&quot;);
		$this-&gt;msg_bootstrap-&gt;ensure_mail_msg_exists('email.bofolder.folder', $this-&gt;debug);
			
		$standard_account = array ('acctnum'        =&gt; 0,
		                           'status'         =&gt; 'enabled',
		                           'display_string' =&gt; '[0] standard'
		                           );

		$extra_account_list = $this-&gt;bopreferences-&gt;ex_accounts_list();
			
		array_unshift($extra_account_list, $standard_account);
		$account_list = $extra_account_list;

		$return = array();
		for ($i=0; $i &lt; count($account_list); $i++)
		{
			if ($account_list[$i]['status'] == 'enabled')
			{
				$account_name = substr($account_list[$i]['display_string'],(strrpos($account_list[$i]['display_string'],']')+2));
				$account_name = lang('mailbox').' \''.$account_name.'\'';
				$id = strval('email_'.$account_list[$i]['acctnum']);
				$return[$id] = array('text'      =&gt; $account_name,
				                     'parent_id' =&gt; '0',
				                     'icon'      =&gt; ''
					                  );

				$folder_list_i = $GLOBALS['phpgw']-&gt;msg-&gt;get_arg_value('folder_list',$account_list[$i]['acctnum']);

				for ($j=0; $j &lt; count($folder_list_i); $j++)
				{
					$separator = $this-&gt;get_IMAP_folder_separator($folder_list_i[$j]['folder_long']);
					$path = explode($separator, $folder_list_i[$j]['folder_long']);

					// calculate parent folder
					if (count($path) == 1)
					{
						$parent = 'email_'.$account_list[$i]['acctnum'];
					}
					else
					{
						//special handling for the courir server
						if ( $path[count($path) - 2] == 'INBOX' &amp;&amp; $separator == '.' )
						{
							$parent = 'email_'.$account_list[$i]['acctnum'];
						}
						else
						{
							$parent = 'email_'.$account_list[$i]['acctnum'].'_'.$path[count($path) - 2];
						}
					}
						
					// parse link to view email folder
					$folderName = $GLOBALS['phpgw']-&gt;msg-&gt;prep_folder_out($folder_list_i[$j]['folder_long']);
					$folderLink = $GLOBALS['phpgw']-&gt;link('/index.php','menuaction=email.uiindex.index'.
					                                      '&amp;fldball[folder]='.$folderName.
					                                      '&amp;fldball[acctnum]='.$account_list[$i]['acctnum']
					                                      );

					$id = 'email_'.$account_list[$i]['acctnum'].'_'.$path[count($path)-1];
					$return[$id] = array('text'      =&gt; $path[count($path)-1],
					                     'title'     =&gt; $folder_list_i[$j]['folder_long'],
					                     'icon'      =&gt; 'email/templates/'.$tpl_set.'/images/folders.png',
					                     'parent_id' =&gt; $parent,
					                     'href'      =&gt; $folderLink,
					                     'target'    =&gt; '_parent'
					                    );
				}
			}
		}
		return array('content' =&gt; $return);
	}
	
/**
* Get the IMAP folder separator
* @access privat
* @return string
*/
	function get_IMAP_folder_separator($string)
	{
		//exchange
		if (strpos($string, '/'))
		{
			$separator = '/';
		}
		//courir
		elseif (strpos($string, '.'))
		{
			$separator = '.';
		}
		else
		{
			$separator = 'I doubt this string is used somewhere';
		}
		return $separator;
	}
}
?&gt;